Only in mplp_ver2: ._cycle.h
diff -crB mplp_ver2/cycle.h mplp_ver2.src-patched/cycle.h
*** mplp_ver2/cycle.h	2014-10-19 21:32:10.000000000 +0200
--- mplp_ver2.src-patched/cycle.h	2014-02-25 10:05:55.000000000 +0100
***************
*** 5,12 ****
   *  Copyright 2008 MIT, 2012 NYU. All rights reserved.
   *
   */
! #ifndef CYCLE_H
! #define CYCLE_H
  
  #include <stdlib.h>
  #include <vector>
--- 5,12 ----
   *  Copyright 2008 MIT, 2012 NYU. All rights reserved.
   *
   */
! #ifndef MPLP_CYCLE_H
! #define MPLP_CYCLE_H
  
  #include <stdlib.h>
  #include <vector>
***************
*** 15,30 ****
  #include <list>
  #include <map>
  #include <queue>
  #include "mplp_alg.h"
  
! #define DEBUG_MODE 1
  
  #define Inf 9999999999.9
  #define CYCLE_THRESH .00001  // TODO: Figure out how to set this
  #define CLUSTER_THR .0000001
  
! typedef map<pair<int, int>, int> mapType;
! typedef vector<vector<pair<int, double> > > adj_type;
  
  // Structure for storing a candidate triplet cluster for tightening
  struct TripletCluster {
--- 15,31 ----
  #include <list>
  #include <map>
  #include <queue>
+ 
  #include "mplp_alg.h"
  
! #define MPLP_DEBUG_MODE 0
  
  #define Inf 9999999999.9
  #define CYCLE_THRESH .00001  // TODO: Figure out how to set this
  #define CLUSTER_THR .0000001
  
! typedef std::map<std::pair<int, int>, int> mapType;
! typedef std::vector<std::vector<std::pair<int, double> > > adj_type;
  
  // Structure for storing a candidate triplet cluster for tightening
  struct TripletCluster {
***************
*** 95,105 ****
  /////////////////////////////////////////////////////////////////////////////////
  // Code to evaluate how good a cycle cluster is
  
! double maximizeIndependently(vector<MulDimArr*> & beliefs)
  {
  	double sum=0.0;
  	int max_at; // not actually needed
! 	for(int i=0; i < beliefs.size(); i++)
  	{
  		sum += beliefs[i]->Max(max_at);
  	}
--- 96,106 ----
  /////////////////////////////////////////////////////////////////////////////////
  // Code to evaluate how good a cycle cluster is
  
! double maximizeIndependently(std::vector<MulDimArr*> & beliefs)
  {
  	double sum=0.0;
  	int max_at; // not actually needed
! 	for(size_t i=0; i < beliefs.size(); i++)
  	{
  		sum += beliefs[i]->Max(max_at);
  	}
***************
*** 107,119 ****
  	return sum;
  }
  
! double getValCycle(vector<MulDimArr*> & beliefs, vector<bool> & b_transpose, vector<int> & assignments)
  {
  	double sum=0.0;
! 	vector<int> inds; inds.push_back(-1); inds.push_back(-1); // temp
  
  	// All except the last edge
! 	for(int i=0; i < beliefs.size()-1; i++)
  	{
  		inds[b_transpose[i]?1:0] = assignments[i];
  		inds[b_transpose[i]?0:1] = assignments[i+1];
--- 108,120 ----
  	return sum;
  }
  
! double getValCycle(std::vector<MulDimArr*> & beliefs, std::vector<bool> & b_transpose, std::vector<int> & assignments)
  {
  	double sum=0.0;
! 	std::vector<int> inds; inds.push_back(-1); inds.push_back(-1); // temp
  
  	// All except the last edge
! 	for(size_t i=0; i < beliefs.size()-1; i++)
  	{
  		inds[b_transpose[i]?1:0] = assignments[i];
  		inds[b_transpose[i]?0:1] = assignments[i+1];
***************
*** 128,134 ****
  	return sum;
  }
  
! double maximizeCycle(vector<MulDimArr*> & beliefs, vector<bool> & b_transpose)
  {
  	double max_val = -Inf;
  
--- 129,135 ----
  	return sum;
  }
  
! double maximizeCycle(std::vector<MulDimArr*> & beliefs, std::vector<bool> & b_transpose)
  {
  	double max_val = -Inf;
  
***************
*** 137,147 ****
  	int second_var_size = beliefs[0]->m_base_sizes[b_transpose[0]?0:1];
  	for(int vo=0; vo < first_var_size; vo++)
  	{
! 		vector<int> inds; inds.push_back(-1); inds.push_back(-1); // temp
  		inds[b_transpose[0]?1:0] = vo;
  
  		// Do first edge (construct initial field)
! 		vector<double> field;
  		for(int v2=0; v2 < second_var_size; v2++)
  		{
  			inds[b_transpose[0]?0:1] = v2;
--- 138,148 ----
  	int second_var_size = beliefs[0]->m_base_sizes[b_transpose[0]?0:1];
  	for(int vo=0; vo < first_var_size; vo++)
  	{
! 	   std::vector<int> inds; inds.push_back(-1); inds.push_back(-1); // temp
  		inds[b_transpose[0]?1:0] = vo;
  
  		// Do first edge (construct initial field)
! 		std::vector<double> field;
  		for(int v2=0; v2 < second_var_size; v2++)
  		{
  			inds[b_transpose[0]?0:1] = v2;
***************
*** 149,157 ****
  		}
  
  		// Go over rest of edges, except last (which has to be treated specially)
! 		for(int i=1; i < beliefs.size()-1; i++)
  		{
! 			vector<double> new_field;
  			for(int v2=0; v2 < beliefs[i]->m_base_sizes[b_transpose[i]?0:1]; v2++)
  			{
  				inds.clear(); inds.push_back(-1); inds.push_back(-1); // temp
--- 150,158 ----
  		}
  
  		// Go over rest of edges, except last (which has to be treated specially)
! 		for(size_t i=1; i < beliefs.size()-1; i++)
  		{
! 		   std::vector<double> new_field;
  			for(int v2=0; v2 < beliefs[i]->m_base_sizes[b_transpose[i]?0:1]; v2++)
  			{
  				inds.clear(); inds.push_back(-1); inds.push_back(-1); // temp
***************
*** 159,168 ****
  
  				// Take max
  				double tmp_max_val = -Inf;
! 				for(int v1=0; v1 < field.size(); v1++)
  				{
  					inds[b_transpose[i]?1:0] = v1;
! 					tmp_max_val = max(tmp_max_val, field[v1]+beliefs[i]->GetVal(inds));
  				}
  				new_field.push_back(tmp_max_val);
  			}
--- 160,169 ----
  
  				// Take max
  				double tmp_max_val = -Inf;
! 				for(size_t v1=0; v1 < field.size(); v1++)
  				{
  					inds[b_transpose[i]?1:0] = v1;
! 					tmp_max_val = std::max(tmp_max_val, field[v1]+beliefs[i]->GetVal(inds));
  				}
  				new_field.push_back(tmp_max_val);
  			}
***************
*** 176,188 ****
  
  		// Take max
  		double tmp_max_val = -Inf;
! 		for(int v1=0; v1 < field.size(); v1++)
  		{
  			inds[b_transpose[b_transpose.size()-1]?1:0] = v1;
! 			tmp_max_val = max(tmp_max_val, field[v1]+beliefs[beliefs.size()-1]->GetVal(inds));
  		}
  
! 		max_val = max(max_val, tmp_max_val);
  	}
  	return max_val;
  }
--- 177,189 ----
  
  		// Take max
  		double tmp_max_val = -Inf;
! 		for(size_t v1=0; v1 < field.size(); v1++)
  		{
  			inds[b_transpose[b_transpose.size()-1]?1:0] = v1;
! 			tmp_max_val = std::max(tmp_max_val, field[v1]+beliefs[beliefs.size()-1]->GetVal(inds));
  		}
  
! 		max_val = std::max(max_val, tmp_max_val);
  	}
  	return max_val;
  }
***************
*** 190,205 ****
  /////////////////////////////////////////////////////////////////////////////////
  // Implementation of UAI 2008 algorithm (just for triplets; square functionality removed)
  
! int TightenTriplet(MPLPAlg & mplp, int nclus_to_add_min, int nclus_to_add_max, map<vector<int>, bool >& triplet_set, double & promised_bound) {
  		
    int nClustersAdded = 0;
    int nNewClusters = 0;
  
!   if(DEBUG_MODE)
!     cout << "Doing pre-processing for adding triplet clusters." << endl;
  		
    // Initialize adjacency list (filled in later) TODO: only do this when needed
!   vector<int>* adjacency_list = new vector<int>[mplp.m_var_sizes.size()];
  	
    // Construct adjacency list for the graph
    // Iterate over all of the edges (we do this by looking at the edge intersection sets)
--- 191,206 ----
  /////////////////////////////////////////////////////////////////////////////////
  // Implementation of UAI 2008 algorithm (just for triplets; square functionality removed)
  
! int TightenTriplet(MPLPAlg & mplp, int nclus_to_add_min, int nclus_to_add_max, std::map<std::vector<int>, bool >& triplet_set, double & promised_bound) {
  		
    int nClustersAdded = 0;
    int nNewClusters = 0;
  
!   if(MPLP_DEBUG_MODE)
!      std::cout << "Doing pre-processing for adding triplet clusters." << std::endl;
  		
    // Initialize adjacency list (filled in later) TODO: only do this when needed
!   std::vector<std::vector<int> > adjacency_list(mplp.m_var_sizes.size());
  	
    // Construct adjacency list for the graph
    // Iterate over all of the edges (we do this by looking at the edge intersection sets)
***************
*** 212,225 ****
      }
  
    // Sort the adjacency list, for fast intersections later
!   for(int i=0; i < sizeof(adjacency_list)/sizeof(vector<int>); i++) 
      {
        sort(adjacency_list[i].begin(), adjacency_list[i].end());
      }
  
    // Count the number of triangles
!   vector<int>::iterator intersects_iter_end;
!   vector<int> commonNodes(mplp.m_var_sizes.size());
    for(mapType::const_iterator it = mplp.m_intersect_map.begin(); it != mplp.m_intersect_map.end(); ++it)
      {
  
--- 213,226 ----
      }
  
    // Sort the adjacency list, for fast intersections later
!   for(size_t i=0; i < sizeof(adjacency_list)/sizeof(std::vector<int>); i++)
      {
        sort(adjacency_list[i].begin(), adjacency_list[i].end());
      }
  
    // Count the number of triangles
!   std::vector<int>::iterator intersects_iter_end;
!   std::vector<int> commonNodes(mplp.m_var_sizes.size());
    for(mapType::const_iterator it = mplp.m_intersect_map.begin(); it != mplp.m_intersect_map.end(); ++it)
      {
  
***************
*** 229,235 ****
        // Now find all neighbors of both i and j to see where the triangles are
        intersects_iter_end = set_intersection(adjacency_list[i].begin(), adjacency_list[i].end(), adjacency_list[j].begin(), adjacency_list[j].end(), commonNodes.begin());
  
!       for(vector<int>::const_iterator n=commonNodes.begin(); n != intersects_iter_end; ++n)
  	{
  	  // Since a triplet shows up three times as an edge plus
  	  // a node, we only consider it for the case when n<i and n<j
--- 230,236 ----
        // Now find all neighbors of both i and j to see where the triangles are
        intersects_iter_end = set_intersection(adjacency_list[i].begin(), adjacency_list[i].end(), adjacency_list[j].begin(), adjacency_list[j].end(), commonNodes.begin());
  
!       for(std::vector<int>::const_iterator n=commonNodes.begin(); n != intersects_iter_end; ++n)
  	{
  	  // Since a triplet shows up three times as an edge plus
  	  // a node, we only consider it for the case when n<i and n<j
***************
*** 239,253 ****
      }
  
    if(nNewClusters == 0) {
!     if(DEBUG_MODE)
!       cout << "nNewClusters = 0. Returning." << endl;
      
-     delete []adjacency_list;
      return 0;
    }
  
!   if(DEBUG_MODE)
!     cout << "Looking for triangle clusters to add (" << nNewClusters << " triplets) " << endl;
  
    // TODO: put this elsewhere so that the space isn't re-allocated continuously?
    // Enumerate over all of the edges
--- 240,253 ----
      }
  
    if(nNewClusters == 0) {
!     if(MPLP_DEBUG_MODE)
!        std::cout << "nNewClusters = 0. Returning." << std::endl;
      
      return 0;
    }
  
!   if(MPLP_DEBUG_MODE)
!      std::cout << "Looking for triangle clusters to add (" << nNewClusters << " triplets) " << std::endl;
  
    // TODO: put this elsewhere so that the space isn't re-allocated continuously?
    // Enumerate over all of the edges
***************
*** 256,262 ****
    int index=0;
  			
    // Iterate over all of the edge intersection sets
!   vector<int> tripAssignment; tripAssignment.push_back(-1); tripAssignment.push_back(-1); tripAssignment.push_back(-1);
    for(mapType::const_iterator it = mplp.m_intersect_map.begin(); it != mplp.m_intersect_map.end(); ++it)
      {
  				
--- 256,262 ----
    int index=0;
  			
    // Iterate over all of the edge intersection sets
!   std::vector<int> tripAssignment; tripAssignment.push_back(-1); tripAssignment.push_back(-1); tripAssignment.push_back(-1);
    for(mapType::const_iterator it = mplp.m_intersect_map.begin(); it != mplp.m_intersect_map.end(); ++it)
      {
  				
***************
*** 268,274 ****
        // TEMP TEMP -- fails at i=0, j=1, on i==3.
        intersects_iter_end = set_intersection(adjacency_list[i].begin(), adjacency_list[i].end(), adjacency_list[j].begin(), adjacency_list[j].end(), commonNodes.begin());
  				
!       for(vector<int>::const_iterator n=commonNodes.begin(); n != intersects_iter_end; ++n)
  	{
  	  int k = *n;
  					
--- 268,274 ----
        // TEMP TEMP -- fails at i=0, j=1, on i==3.
        intersects_iter_end = set_intersection(adjacency_list[i].begin(), adjacency_list[i].end(), adjacency_list[j].begin(), adjacency_list[j].end(), commonNodes.begin());
  				
!       for(std::vector<int>::const_iterator n=commonNodes.begin(); n != intersects_iter_end; ++n)
  	{
  	  int k = *n;
  					
***************
*** 283,296 ****
  
  	  // Find the intersection sets for this triangle
  	  newCluster[index].ij_intersect_loc = ij_intersect_loc;
! 	  vector<int> jk_edge; jk_edge.push_back(newCluster[index].j); jk_edge.push_back(newCluster[index].k);
  	  newCluster[index].jk_intersect_loc = mplp.FindIntersectionSet(jk_edge);
! 	  vector<int> ki_edge; ki_edge.push_back(newCluster[index].k); ki_edge.push_back(newCluster[index].i);
  	  newCluster[index].ki_intersect_loc = mplp.FindIntersectionSet(ki_edge);					
  
  	  // Construct the beliefs for each edge, which will be maximized below
! 	  vector<MulDimArr*> beliefs;
! 	  vector<bool> b_transpose;
  	  beliefs.push_back(&mplp.m_sum_into_intersects[newCluster[index].ij_intersect_loc]);
  	  b_transpose.push_back(mplp.m_all_intersects[newCluster[index].ij_intersect_loc][0] != newCluster[index].i); // i first
  	  beliefs.push_back(&mplp.m_sum_into_intersects[newCluster[index].jk_intersect_loc]);
--- 283,296 ----
  
  	  // Find the intersection sets for this triangle
  	  newCluster[index].ij_intersect_loc = ij_intersect_loc;
! 	  std::vector<int> jk_edge; jk_edge.push_back(newCluster[index].j); jk_edge.push_back(newCluster[index].k);
  	  newCluster[index].jk_intersect_loc = mplp.FindIntersectionSet(jk_edge);
! 	  std::vector<int> ki_edge; ki_edge.push_back(newCluster[index].k); ki_edge.push_back(newCluster[index].i);
  	  newCluster[index].ki_intersect_loc = mplp.FindIntersectionSet(ki_edge);					
  
  	  // Construct the beliefs for each edge, which will be maximized below
! 	  std::vector<MulDimArr*> beliefs;
! 	  std::vector<bool> b_transpose;
  	  beliefs.push_back(&mplp.m_sum_into_intersects[newCluster[index].ij_intersect_loc]);
  	  b_transpose.push_back(mplp.m_all_intersects[newCluster[index].ij_intersect_loc][0] != newCluster[index].i); // i first
  	  beliefs.push_back(&mplp.m_sum_into_intersects[newCluster[index].jk_intersect_loc]);
***************
*** 320,329 ****
    //       Make the sorting and adding independent of the type of graph...
  			
    // Sort the clusters by the bound
!   sort(newCluster, newCluster+nNewClusters);
  
!   if(DEBUG_MODE)
!     printf(" -- Considered %d clusters, smallest bound %g, largest bound %g\n", nNewClusters, newCluster[max(nNewClusters-nclus_to_add_max, 0)].bound, newCluster[nNewClusters-1].bound);
  
    promised_bound = newCluster[nNewClusters-1].bound;
  
--- 320,329 ----
    //       Make the sorting and adding independent of the type of graph...
  			
    // Sort the clusters by the bound
!   std::sort(newCluster, newCluster+nNewClusters);
  
!   if(MPLP_DEBUG_MODE)
!     printf(" -- Considered %d clusters, smallest bound %g, largest bound %g\n", nNewClusters, newCluster[std::max(nNewClusters-nclus_to_add_max, 0)].bound, newCluster[nNewClusters-1].bound);
  
    promised_bound = newCluster[nNewClusters-1].bound;
  
***************
*** 331,363 ****
    for(int clusterId = nNewClusters-1; clusterId >= 0 && nClustersAdded < nclus_to_add_max && (nClustersAdded < nclus_to_add_min || ((newCluster[clusterId].bound >= newCluster[nNewClusters-1].bound/5) && newCluster[clusterId].bound >= CLUSTER_THR)) ; clusterId--)
      {
        // Check to see if this triplet is already being used
!       vector<int> temp;
        temp.push_back(newCluster[clusterId].i);
        temp.push_back(newCluster[clusterId].j);
        temp.push_back(newCluster[clusterId].k);
        sort(temp.begin(), temp.end());
  
!       map<vector<int>, bool >::iterator t_itr = triplet_set.find(temp);
        if (t_itr == triplet_set.end())
! 	triplet_set.insert(pair<vector<int>, bool >(temp, true));
        else {
! 	//	if(DEBUG_MODE)
! 	//	  cout << "   Triplet was already present. Skipping..." << endl;
! 	continue; 
        }
  				
        // Now add cluster ijk
!       vector<int> ijk_inds;
        ijk_inds.push_back(newCluster[clusterId].i); ijk_inds.push_back(newCluster[clusterId].j); ijk_inds.push_back(newCluster[clusterId].k);
  				
!       vector<int> ijk_intersect_inds;
        ijk_intersect_inds.push_back(newCluster[clusterId].ij_intersect_loc);
        ijk_intersect_inds.push_back(newCluster[clusterId].jk_intersect_loc);
        ijk_intersect_inds.push_back(newCluster[clusterId].ki_intersect_loc);
  				
        mplp.AddRegion(ijk_inds, ijk_intersect_inds);
  	
!       if(DEBUG_MODE)
  	printf("Cluster added on nodes %d, %d, %d\n", newCluster[clusterId].i, newCluster[clusterId].j, newCluster[clusterId].k);
        // TODO: log which clusters are chosen...
  				
--- 331,363 ----
    for(int clusterId = nNewClusters-1; clusterId >= 0 && nClustersAdded < nclus_to_add_max && (nClustersAdded < nclus_to_add_min || ((newCluster[clusterId].bound >= newCluster[nNewClusters-1].bound/5) && newCluster[clusterId].bound >= CLUSTER_THR)) ; clusterId--)
      {
        // Check to see if this triplet is already being used
!       std::vector<int> temp;
        temp.push_back(newCluster[clusterId].i);
        temp.push_back(newCluster[clusterId].j);
        temp.push_back(newCluster[clusterId].k);
        sort(temp.begin(), temp.end());
  
!       std::map<std::vector<int>, bool >::iterator t_itr = triplet_set.find(temp);
        if (t_itr == triplet_set.end())
!          triplet_set.insert(std::pair<std::vector<int>, bool >(temp, true));
        else {
!          //	if(MPLP_DEBUG_MODE)
!          //	  cout << "   Triplet was already present. Skipping..." << endl;
!          continue;
        }
  				
        // Now add cluster ijk
!       std::vector<int> ijk_inds;
        ijk_inds.push_back(newCluster[clusterId].i); ijk_inds.push_back(newCluster[clusterId].j); ijk_inds.push_back(newCluster[clusterId].k);
  				
!       std::vector<int> ijk_intersect_inds;
        ijk_intersect_inds.push_back(newCluster[clusterId].ij_intersect_loc);
        ijk_intersect_inds.push_back(newCluster[clusterId].jk_intersect_loc);
        ijk_intersect_inds.push_back(newCluster[clusterId].ki_intersect_loc);
  				
        mplp.AddRegion(ijk_inds, ijk_intersect_inds);
  	
!       if(MPLP_DEBUG_MODE)
  	printf("Cluster added on nodes %d, %d, %d\n", newCluster[clusterId].i, newCluster[clusterId].j, newCluster[clusterId].k);
        // TODO: log which clusters are chosen...
  				
***************
*** 365,371 ****
      }
  
    delete []newCluster;
-   delete []adjacency_list;
  
    return nClustersAdded;
  }
--- 365,370 ----
***************
*** 375,390 ****
  // Everything that follows is for the UAI 2012 cycle finding algorithm which
  // can find arbitrary-length cycles to use in tightening the relaxation.
  
! bool edge_sorting(list<int> i, list<int> j) {
  	return i.back() > j.back();
  }
  
! bool edge_sorting3(pair<pair<int, int>, double> i, pair<pair<int, int>, double> j) {
    return i.second > j.second;
  }
  
  // De-allocate memory relating to the projection graph (TODO: finish writing this)
! void delete_projection_graph(int num_vars, vector<vector<int> > &projection_map, vector<int> &projection_imap_var, adj_type &projection_adjacency_list, double* &array_of_sij) {
  
    //for(int node=0; node < num_vars; node++)
    //  delete []projection_map[node];
--- 374,389 ----
  // Everything that follows is for the UAI 2012 cycle finding algorithm which
  // can find arbitrary-length cycles to use in tightening the relaxation.
  
! bool edge_sorting(std::list<int> i, std::list<int> j) {
  	return i.back() > j.back();
  }
  
! bool edge_sorting3(std::pair<std::pair<int, int>, double> i, std::pair<std::pair<int, int>, double> j) {
    return i.second > j.second;
  }
  
  // De-allocate memory relating to the projection graph (TODO: finish writing this)
! void delete_projection_graph(int num_vars, std::vector<std::vector<int> > &projection_map, std::vector<int> &projection_imap_var, adj_type &projection_adjacency_list, double* &array_of_sij) {
  
    //for(int node=0; node < num_vars; node++)
    //  delete []projection_map[node];
***************
*** 398,404 ****
  }
  
  // Compute a single edge weight in the projection graph
! double find_smn(const vector<int>& partition_i, int var_i_size, const vector<int>& partition_j, int var_j_size, MulDimArr* edge_belief) {
  
    int* whole_i = new int[var_i_size];
    int* whole_j = new int[var_j_size];  
--- 397,403 ----
  }
  
  // Compute a single edge weight in the projection graph
! double find_smn(const std::vector<int>& partition_i, int var_i_size, const std::vector<int>& partition_j, int var_j_size, MulDimArr* edge_belief) {
  
    int* whole_i = new int[var_i_size];
    int* whole_j = new int[var_j_size];  
***************
*** 410,418 ****
    }
  
    double smn = -Inf;
!   for (int i = 0; i < partition_i.size(); i++) {
      whole_i[partition_i[i]] = 1;
!     for (int j = 0; j < partition_j.size(); j++) {
        whole_j[partition_j[j]] = 1;
      }
    }
--- 409,417 ----
    }
  
    double smn = -Inf;
!   for (size_t i = 0; i < partition_i.size(); i++) {
      whole_i[partition_i[i]] = 1;
!     for (size_t j = 0; j < partition_j.size(); j++) {
        whole_j[partition_j[j]] = 1;
      }
    }
***************
*** 421,432 ****
    for (int i = 0; i < var_i_size; i++) {    
      for (int j = 0; j < var_j_size; j++) {
        if (whole_i[i] == whole_j[j]) {
!         vector<int> inds; inds.push_back(i); inds.push_back(j);
          double temp_val = edge_belief->GetVal(inds);
          if (smn < temp_val) smn = temp_val;
        }
        else {
!         vector<int> inds; inds.push_back(i); inds.push_back(j);
          double temp_val = edge_belief->GetVal(inds);
          if (sec_max < temp_val) sec_max = temp_val;
        }
--- 420,431 ----
    for (int i = 0; i < var_i_size; i++) {    
      for (int j = 0; j < var_j_size; j++) {
        if (whole_i[i] == whole_j[j]) {
!          std::vector<int> inds; inds.push_back(i); inds.push_back(j);
          double temp_val = edge_belief->GetVal(inds);
          if (smn < temp_val) smn = temp_val;
        }
        else {
!          std::vector<int> inds; inds.push_back(i); inds.push_back(j);
          double temp_val = edge_belief->GetVal(inds);
          if (sec_max < temp_val) sec_max = temp_val;
        }
***************
*** 441,462 ****
  }
  
  // Compute a single edge weight in the projection graph (more efficiently)
! double find_smn_state_i(int single_i, int var_i_size, const vector<int>& partition_j, int var_j_size, MulDimArr* edge_belief, vector<vector<double> >& max_i_bij_not_xi) {
  	double max, sec_max;
  	max = sec_max = -Inf;
! 	double whole_i[var_i_size];
  	double whole_j[var_j_size];
! 	for (int i = 0; i < var_i_size; i++) {
  		whole_i[i] = 0;
! 	}
  	for (int j = 0; j < var_j_size; j++) {
  		whole_j[j] = 0;
  	}
! 	whole_i[single_i] = 1;
! 	for (int j = 0; j < partition_j.size(); j++) { 
  		//brute force max_{pi(x_i)=pi(x_j)=1}bij(x_i,x_j)
  		whole_j[partition_j[j]] = 1;
! 		vector<int> inds; inds.push_back(single_i); inds.push_back(partition_j[j]);
  		double tmp = edge_belief->GetVal(inds);
  		if (max < tmp) max = tmp;
  	}
--- 440,461 ----
  }
  
  // Compute a single edge weight in the projection graph (more efficiently)
! double find_smn_state_i(int single_i, int var_i_size, const std::vector<int>& partition_j, int var_j_size, MulDimArr* edge_belief, std::vector<std::vector<double> >& max_i_bij_not_xi) {
  	double max, sec_max;
  	max = sec_max = -Inf;
! 	//double whole_i[var_i_size];
  	double whole_j[var_j_size];
! 	/*for (int i = 0; i < var_i_size; i++) {
  		whole_i[i] = 0;
! 	}*/
  	for (int j = 0; j < var_j_size; j++) {
  		whole_j[j] = 0;
  	}
! 	//whole_i[single_i] = 1;
! 	for (size_t j = 0; j < partition_j.size(); j++) {
  		//brute force max_{pi(x_i)=pi(x_j)=1}bij(x_i,x_j)
  		whole_j[partition_j[j]] = 1;
! 		std::vector<int> inds; inds.push_back(single_i); inds.push_back(partition_j[j]);
  		double tmp = edge_belief->GetVal(inds);
  		if (max < tmp) max = tmp;
  	}
***************
*** 464,470 ****
  	for (int j = 0; j < var_j_size; j++) {
  		if (whole_j[j] == 0) {
  			//bruteforce max_{pi(x_i)=pi(x_j)=0}bij(x_i,x_j)
! 			vector<int> inds; inds.push_back(single_i); inds.push_back(j);
  			double tmp = edge_belief->GetVal(inds);
  			if (sec_max < tmp) sec_max = tmp; 
  
--- 463,469 ----
  	for (int j = 0; j < var_j_size; j++) {
  		if (whole_j[j] == 0) {
  			//bruteforce max_{pi(x_i)=pi(x_j)=0}bij(x_i,x_j)
! 		   std::vector<int> inds; inds.push_back(single_i); inds.push_back(j);
  			double tmp = edge_belief->GetVal(inds);
  			if (sec_max < tmp) sec_max = tmp; 
  
***************
*** 479,500 ****
  }
  
  // Compute a single edge weight in the projection graph (more efficiently)
! double find_smn_state_j(const vector<int>& partition_i, int var_i_size, int single_j, int var_j_size, MulDimArr* edge_belief, vector<vector<double> >& max_j_bij_not_xj) {
  	double max, sec_max;
  	max = sec_max = -Inf;
  	double whole_i[var_i_size];
! 	double whole_j[var_j_size];
  	for (int i = 0; i < var_i_size; i++) {
  		whole_i[i] = 0;
  	}
! 	for (int j = 0; j < var_j_size; j++) {
  		whole_j[j] = 0;
! 	}
! 	whole_j[single_j] = 1;
! 	for (int i = 0; i < partition_i.size(); i++) { 
  		//brute force max_{pi(x_i)=pi(x_j)=1}bij(x_i,x_j)
  		whole_i[partition_i[i]] = 1;
! 		vector<int> inds; inds.push_back(partition_i[i]); inds.push_back(single_j);
  		double tmp = edge_belief->GetVal(inds);
  		if (max < tmp) max = tmp;
  	}
--- 478,499 ----
  }
  
  // Compute a single edge weight in the projection graph (more efficiently)
! double find_smn_state_j(const std::vector<int>& partition_i, int var_i_size, int single_j, int var_j_size, MulDimArr* edge_belief, std::vector<std::vector<double> >& max_j_bij_not_xj) {
  	double max, sec_max;
  	max = sec_max = -Inf;
  	double whole_i[var_i_size];
! 	//double whole_j[var_j_size];
  	for (int i = 0; i < var_i_size; i++) {
  		whole_i[i] = 0;
  	}
! 	/*for (int j = 0; j < var_j_size; j++) {
  		whole_j[j] = 0;
! 	}*/
! 	//whole_j[single_j] = 1;
! 	for (size_t i = 0; i < partition_i.size(); i++) {
  		//brute force max_{pi(x_i)=pi(x_j)=1}bij(x_i,x_j)
  		whole_i[partition_i[i]] = 1;
! 		std::vector<int> inds; inds.push_back(partition_i[i]); inds.push_back(single_j);
  		double tmp = edge_belief->GetVal(inds);
  		if (max < tmp) max = tmp;
  	}
***************
*** 502,508 ****
  	for (int i = 0; i < var_i_size; i++) {
  		if (whole_i[i] == 0) {
  			//bruteforce max_{pi(x_i)=pi(x_j)=0}bij(x_i,x_j)
! 			vector<int> inds; inds.push_back(i); inds.push_back(single_j);
  			double tmp = edge_belief->GetVal(inds);
  			if (sec_max < tmp) sec_max = tmp; 
  
--- 501,507 ----
  	for (int i = 0; i < var_i_size; i++) {
  		if (whole_i[i] == 0) {
  			//bruteforce max_{pi(x_i)=pi(x_j)=0}bij(x_i,x_j)
! 		   std::vector<int> inds; inds.push_back(i); inds.push_back(single_j);
  			double tmp = edge_belief->GetVal(inds);
  			if (sec_max < tmp) sec_max = tmp; 
  
***************
*** 519,531 ****
  
  // This will find the best partitioning of the states of a single edge
  // Implements the FindPartition algorithm described in supplementary material of UAI 2012 paper.
! void find_partition(vector<map<vector<int>, int> >& partition_set, MPLPAlg& mplp, MulDimArr* edge_belief, int index_i, int index_j) {
  
    int size_i = mplp.m_var_sizes[index_i];
    int size_j = mplp.m_var_sizes[index_j];
  
!   vector<Node*> x_i; //partition for node i
!   vector<Node*> x_j; //partition for node j
  
    for (int i = 0; i < size_i; i++) {
      Node* t = new Node(2);
--- 518,530 ----
  
  // This will find the best partitioning of the states of a single edge
  // Implements the FindPartition algorithm described in supplementary material of UAI 2012 paper.
! void find_partition(std::vector<std::map<std::vector<int>, int> >& partition_set, MPLPAlg& mplp, MulDimArr* edge_belief, int index_i, int index_j) {
  
    int size_i = mplp.m_var_sizes[index_i];
    int size_j = mplp.m_var_sizes[index_j];
  
!   std::vector<Node*> x_i; //partition for node i
!   std::vector<Node*> x_j; //partition for node j
  
    for (int i = 0; i < size_i; i++) {
      Node* t = new Node(2);
***************
*** 537,553 ****
    }
  
    // sort edges by their weights in decreasing order
!   vector<pair<pair<int, int>, double> > sorted_edge_set;
    for (int i = 0; i < size_i; i++) {
      for (int j = 0; j < size_j; j++) {
!       vector<int> inds; inds.push_back(i); inds.push_back(j);
        double temp_val = edge_belief->GetVal(inds);
!       sorted_edge_set.push_back(pair<pair<int, int>, double>(make_pair(make_pair(i, j), temp_val)));
      }
    }
    sort(sorted_edge_set.begin(), sorted_edge_set.end(), edge_sorting3);
  
!   vector<pair<pair<int, int>, double> >::iterator it = sorted_edge_set.begin();
    double val_s = it->second; //val_s = bij(x_i^*, x_j^*);
  
    // union find step;
--- 536,552 ----
    }
  
    // sort edges by their weights in decreasing order
!   std::vector<std::pair<std::pair<int, int>, double> > sorted_edge_set;
    for (int i = 0; i < size_i; i++) {
      for (int j = 0; j < size_j; j++) {
!        std::vector<int> inds; inds.push_back(i); inds.push_back(j);
        double temp_val = edge_belief->GetVal(inds);
!       sorted_edge_set.push_back(std::pair<std::pair<int, int>, double>(std::make_pair(std::make_pair(i, j), temp_val)));
      }
    }
    sort(sorted_edge_set.begin(), sorted_edge_set.end(), edge_sorting3);
  
!   std::vector<std::pair<std::pair<int, int>, double> >::iterator it = sorted_edge_set.begin();
    double val_s = it->second; //val_s = bij(x_i^*, x_j^*);
  
    // union find step;
***************
*** 590,603 ****
    }
  
    if (size_i != 2 && size_j != 2) {
!     cout << "something is wrong" << endl;
    }
    
    if (size_i == 1 || size_j == 1) {
!     cout << "should not happen" << endl;
      return;
    }
!   vector<int> part_i, part_j; 
  
    //find the smallest partition and use it as an index
    // If there's a tie, use the partition with the smallest index. Keep it sorted.
--- 589,602 ----
    }
  
    if (size_i != 2 && size_j != 2) {
!      std::cout << "something is wrong" << std::endl;
    }
    
    if (size_i == 1 || size_j == 1) {
!      std::cout << "should not happen" << std::endl;
      return;
    }
!   std::vector<int> part_i, part_j;
  
    //find the smallest partition and use it as an index
    // If there's a tie, use the partition with the smallest index. Keep it sorted.
